<?php
require_once('config.php.inc');
?>
<html>

<head>
<link rel="stylesheet" type="text/css" href="/pttxwm/styles.css">
<title>pttXwm <?php echo $pttxwm_rel ?> - XenServer Web Management</title>
</head>

<body>


<h1 id="header">You are connected to <b><?php echo shell_exec('/bin/hostname'); ?></b> (<?php echo $_SERVER['SERVER_ADDR']; ?>) server (your IP: <?php echo $_SERVER['REMOTE_ADDR']; ?>) </h1>

<div class="logo">
<p class="warn">
<b>Notes:</b><br>
When starting a server, IP address of the server could not be correct, since it's only assigned on boot.<br>
Click on "Shutdown" and the machine will get a shutdown/power button event.<br>
Click on "Destroy" and the machine will be "hard" shutdown (killed).<br>
</p>
<p class="info">
<a href="http://<?php echo $_SERVER['SERVER_NAME']; ?>:<?php echo $_SERVER['SERVER_PORT']; ?>/pttxwm"><b>Refresh Page</b></a>
</p>
</div>


<?php

if ($_POST["servername"] <> '')	{

	$output = "";
	if ($_POST["action"] == 'destroy') {
		// DESTROY
		$output = shell_exec('sudo '.$xen_toolstack.' destroy '.$_POST["servername"]);
	} else if ($_POST["action"] == 'shutdown') {
		// SHUTDOWN
		$output = shell_exec('sudo '.$xen_toolstack.' shutdown '.$_POST["servername"]);
	} else if ($_POST["action"] == 'start') {
		// START
		$output = shell_exec('sudo '.$xen_toolstack.' create '.$xen_cfg_dir.'/'.$_POST["servername"].$xen_cfg_ext);
	} else if ($_POST["action"] == 'cdattach') {
		// ATTACH CD
		shell_exec('sudo '.$xen_toolstack.' block-configure '.$_POST["servername"].' file://'.$iso_dir.'/'.$dummy_iso.' hdc:cdrom r ; sleep 3');
		if (isset($_POST["cd_tray"])) { 
			if ($_POST["cd_tray"] == 'phy') {
				$output = shell_exec('sudo '.$xen_toolstack.' block-configure '.$_POST["servername"].' phy:'.$phy_cd_dev.' hdc:cdrom r');
			} else {
				echo 'sudo '.$xen_toolstack.' block-configure '.$_POST["servername"].' file://'.$iso_dir.'/'.$_POST["cd_tray"].' hdc:cdrom r';
				$output = shell_exec('sudo '.$xen_toolstack.' block-configure '.$_POST["servername"].' file://'.$iso_dir.'/'.$_POST["cd_tray"].' hdc:cdrom r');
			}
		}
	}
	echo $output;
}

// ============================================================
// RUNNING SERVER'S LIST
// ============================================================

$output = shell_exec('sudo '.$xen_toolstack.' list');

// Put each individual line into an array
$array  =   explode("\n", $output);


// render Table with infos about running servers
echo '<h1 id="runserver">Running Servers</h1>';
echo '<table border="1">';
echo "<tr>";
echo "<th>Name</th><th>ID</th><th>Mem</th><th>VCPUs</th><th>State</th><th>Time(s)</th><th>IP</th><th>Stop</th><th>CD Tray</th><th>Info</th><th>VNC Port</th>";
echo "</tr>";


$counter = 0;
for ($i = 2; $i < count($array)-1; $i++) {
	$itemarray = explode(" ", $array[$i]);

	echo "<tr>";

	for ($x = 0; $x < count($itemarray); $x++) {
		if ($itemarray[$x] != "")	{
			echo '<td class="runserver">';
			echo "$itemarray[$x]";
			echo "</td>";
		}		
	}

	// den Running server in ein array speichern
	//echo $itemarray[0];
	$runinngsrvarray[$counter] = $itemarray[0];
	$counter++;

	// Servers' ip
	echo "<td>";
	echo gethostbyname($itemarray[0]);
	echo "</td>";

	// Button for shutdown/destroy
	echo "<td>";
	echo '<form action="" method="POST" onsubmit="return confirm(\'ALERT!!!!!!!\n\nYou are about to SHUTDOWN '.$itemarray[0].' server!!!\nAre you sure to continue?\');">
		<input type="hidden" name="servername" value="'.$itemarray[0].'" />
		<input type="hidden" name="action" value="shutdown" />
		<input name="shutdown" type="submit" value="Shutdown">
	</form>';
	echo '<form action="" method="POST" onsubmit="return confirm(\'ALERT!!!!!!!\n\nYou are about to KILL (destroy) '.$itemarray[0].' server!!!\nAre you sure to continue?\');">
		<input type="hidden" name="servername" value="'.$itemarray[0].'" />
		<input type="hidden" name="action" value="destroy" />
		<input name="destroy" type="submit" value="   Destroy   ">
                <!-- input type="image" src="images/stop.jpg" alt="Kill the Server" / -->
	</form>';
	echo "</td>";

	// dropdown menu for attach iso/physical cd drive
	echo "<td>";
	$cfg_vcd="";
	echo '<form action="" method="POST">';
	echo "<select name=\"cd_tray\"></option>";
	echo "<option select value=\"\"></option>";
	echo "<strong><option select value=\"phy\">&lt;CD Drive&gt;</option></strong>";
	foreach (preg_grep('/[^\.].iso/', scandir($iso_dir)) as $file) {
               if($iso_dir==$cfg_vcd)
                        $dtext = "selected";
                else
                        $dtext = "";
                echo "<option $dtext value=\"$file\">".str_replace( '.iso','',$file)."</option>";
	}
	echo "</select>";
	echo "<br>";
	echo '
		<input type="hidden" name="servername" value="'.$itemarray[0].'" />
		<input type="hidden" name="action" value="cdattach" />
		<input name="attach" type="submit" value="attach device">
	</form>';
	echo "</td>";

	echo "<td>";
	$output = shell_exec('/usr/bin/head -n 1 '.$xen_cfg_dir.'/'.$itemarray[0].$xen_cfg_ext);
	echo $output;
	echo "</td>";

        echo "<td>";
	// for this to work vncdisplay must be the second option:
	//   EG : vfb = [ 'type=vnc,vncdisplay=03,v....
        $output = shell_exec('/bin/grep vncdisplay '.$xen_cfg_dir.'/'.$itemarray[0].$xen_cfg_ext.' | grep -v ^# | cut -d"=" -f 4 | cut -d"," -f1');
        echo $_SERVER['SERVER_NAME'].':59'.$output;
        echo "<br><a href=\"http://".$_SERVER['SERVER_NAME'].":".$tomcat_port."/".$guacamole_dir."\" target=\"_blank\">Browser console</a>";
        echo "</td>";

	echo "</tr>";
	// echo $array[$i];
}

echo "</table>";


// ============================================================
// AVAILABLE SERVERS' LIST
// ============================================================

$counter = 0;
foreach (preg_grep('/[^.].cfg/', scandir($xen_cfg_dir)) as $file) {
	if ($file[0] != '.') {
		$allsrvarray[$counter] = str_replace( '.cfg','',$file);
		$counter++;
	}
}

/*
print_r($allsrvarray);
echo '<br>';
print_r($runinngsrvarray);
*/

echo '<h1 id="notrunserver">Available Servers</h1>';
echo '<table border="1">';
echo "<tr>";
echo "<th>Name</th><th>Start</th><th>Info</th>";
echo "</tr>";
if (0 == count($runinngsrvarray)) {

        foreach ($allsrvarray  as $key => $value ) {

                echo '<tr><td class="stopserver">';
                //echo str_replace('.cfg', '', $value);
                echo $value;
                echo '</td>';
                echo '<td>';

                echo '
                <form action="" method="POST">
                        <input type="hidden" name="servername" value="'.$value.'" />
                        <input type="hidden" name="action" value="start" />
			<INPUT TYPE="image" SRC="images/xwm_start.png" ALT="Start the server">
                        <!-- <input name="XY" type="submit" value="Start"> -->
                </form>';

                echo '</td>';
                echo '<td>';
		$output = shell_exec('/usr/bin/head -n 1 '.$xen_cfg_dir.'/'.$value.$xen_cfg_ext);
		echo $output;
                echo '</td>';
		echo '</tr>';
        }

} else {

	foreach( array_diff($allsrvarray,$runinngsrvarray) as $key => $value) {

                echo '<tr><td class="stopserver">';
                echo $value;
                echo '</td>';
                echo '<td>';

                echo '
                <form action="" method="POST">
                        <input type="hidden" name="servername" value="'.$value.'" />
                        <input type="hidden" name="action" value="start" />
			<INPUT TYPE="image" SRC="images/xwm_start.png" ALT="Start the server">
                        <!-- <input name="XY" type="submit" value="Start"> -->
                </form>';
                echo '</td>';
                echo '<td>';

		$output = shell_exec('/usr/bin/head -n 1 '.$xen_cfg_dir.'/'.$value.$xen_cfg_ext);
		echo $output;

                echo '</td>';
		echo '</tr>';
	}

}
echo '</table>';


// ============================================================
// SERVERS' STATUS
// ============================================================

$output = shell_exec('sudo /usr/sbin/xentop -b -i 1 -f');

// Put each individual line into an array
$arrayxentop  =  explode("\n", $output);

// render Table with infos about running servers
echo '<h1>Status informations (xentop)</h1>';
echo '<table border="1">';

$counter = 0;

for ($i = 0; $i < count($arrayxentop)-1; $i++) {

	$arrayxentop[$i] = str_replace('no limit','no_limit',$arrayxentop[$i]);

	$itemarray = explode(" ", $arrayxentop[$i]);
        echo "<tr>";
        for ($x = 0; $x < count($itemarray); $x++) {
                if ($itemarray[$x] != "") {
			if ($i == 0)
	                        echo "<th>$itemarray[$x]</th>";
			else
                        	echo "<td>$itemarray[$x]</td>";
                }
        }
        echo "</tr>";
}
echo "</table>";


?>


</body>
</html>
